#include "worker.h"
#include <stdlib.h>

#define UNUSED(VAR) (void)(VAR)



int worker_init(worker_ctx *worker, size_t number_of_threads)
{
    UNUSED(number_of_threads);
    if (worker == NULL) {
        return NULL_ERR;
    }
    return queue_init(&(worker->_jobs_queue));
}


int worker_push_job(worker_ctx *worker, void (*job) (void *), void *data)
{
    if (worker == NULL || job == NULL) {
        return NULL_ERR;
    }

    worker_unit *to_queue = (worker_unit *) malloc(sizeof(worker_unit));
    to_queue->_func = job;
    to_queue->_data = data;

    return queue_enqueue(&(worker->_jobs_queue), (void *) to_queue);
}


int worker_exec(worker_ctx *worker)
{
    if (worker == NULL) {
        return NULL_ERR;
    }

    void *to_execute = NULL;
    while ((to_execute = queue_dequeue(&(worker->_jobs_queue))) != NULL) {
        worker_unit *job = (worker_unit *) to_execute;
        job->_func(job->_data);
        free(to_execute);
    }
    return OK;
}


int worker_destroy(worker_ctx *worker)
{
    //TODO there you should signal all threads to end themselves and join them
    UNUSED(worker);
    return OK;
}

//TODO Here implement function which will be used as job executor with following prototype
// static void* worker_thread(void *);
