#ifndef _THREAD_POOL_H
#define _THREAD_POOL_H

#include "queue.h"
#include <stdlib.h>

/**
 * Context of worker, Currently worker only needs queue.
 * @TODO extend this to contain thread related informations.
 */
typedef struct _worker_ctx {
    queue_t _jobs_queue;
} worker_ctx;

/**
 * Unit of runable job.
 * @TODO You will need to add some informations about threads to this structure.
 */
typedef struct {
    void (*_func) (void *);
    void *_data;
} worker_unit;



/**
 * Initialize worker context
 * 
 * @TODO There you should crate the threads and start them, so they will
 * wait for elements to appear in queue.
 *
 * @param worker holder to be initialized
 * @param number_of_threads unused
 * @return OK if worker is initialized, NULL_ERR if worker is NULL 
 */
int worker_init(worker_ctx *worker, size_t nubmer_of_threads);

/**
 * Pushes job into worker queue to be processed.
 *
 * @param worker worker which should execute job
 * @param job pointer to function which is to be executed
 * @param  data for job
 * @return OK if everything is successfull, NULL_ERR if worker or job are null, MALLOC_ERR if malloc fails 
 */
int worker_push_job(worker_ctx *worker, void (*job) (void *), void *data);

/**
 * Function executes jobs in queue.
 * @TODO this function should be deleted because it will be no longer needed
 *
 * @param worker worker whose jobs should be runned
 * @return OK if everything is successfull
 */
int worker_exec(worker_ctx *worker);

/**
 * @TODO This funciton will stop and destroy threads that are allocated to worker
 *
 * @param worker worker to be destroyed
 * @return OK if everything is successfull, error code otherwise
 */
int worker_destroy(worker_ctx *worker);

#endif /*_THREAD_POOL_H*/
